#ifndef USBLC3301X64_H
#define USBLC3301X64_H

#include <QtCore/qglobal.h>

#ifdef __cplusplus
 extern "C" {            /* Assume C declarations for C++ */
#endif

quint16 ls_libversion();

void ls_initialize(qint32 pipesize, qint32 packetlen);
qint32 ls_enumdevices();
quint16 ls_getfwversion(qint32 index);
const char* ls_getvendorname(qint32 index);
const char* ls_getproductname(qint32 index);
const char* ls_getserialnumber(qint32 index);
quint8 ls_devicecount();
qint32 ls_currentdeviceindex();
qint32 ls_closedevice();
qint32 ls_opendevicebyindex(qint32 index);
qint32 ls_opendevicebyserial(char* serial_num);
qint32 ls_getpipe(void* lpbuffer, qint32 numberbytes);
void ls_waitforpipe(quint32 timeout);
qint32 ls_waitforpipecount(qint32 nNumberOfbytes, quint32 timeout);
qint32 ls_setpacketlength(qint32 packetlen);
quint32 ls_getfps();
const char* ls_geterrorstring(int ierr);

qint32 ls_setmode(quint8 ucmode, quint32 timeout);
qint32 ls_setstate(quint8 ucstate, quint32 timeout);
qint32 ls_setinttime(quint32 dwinttime, quint32 timeout);
qint32 ls_setcfg1(quint8 uccfg1, quint32 timeout);

qint32 ls_getmode(quint8 &ucmode, quint32 timeout);
qint32 ls_getstate(quint8 &ucstate, quint32 timeout);
qint32 ls_getinttime(quint32 &dwinttime, quint32 timeout);
qint32 ls_getcfg1(quint8 &uccfg1, quint32 timeout);
qint32 ls_getpacketlength(qint32 &ipacketlength, quint32 timeout);
qint32 ls_customfirmware(quint32 &dwcustom, quint32 timeout);
qint32 ls_savesettings(quint32 timeout);

qint32 ls_setoffset(quint8 ucleft, quint8 uccenter, quint8 ucright, quint32 timeout);
qint32 ls_setgain(quint8 ucleft, quint8 uccenter, quint8 ucright, quint32 timeout);
qint32 ls_getoffset(quint8 &ucleft, quint8 &uccenter, quint8 &ucright, quint32 timeout);
qint32 ls_getgain(quint8 &ucleft, quint8 &uccenter, quint8 &ucright, quint32 timeout);
const char * ls_getsensorname(void);
qint32 ls_getminmaxtime(quint32 &tmin, quint32 &tmax);
quint16 ls_getpixelcount(void);

#ifdef __cplusplus
}                       /* End of extern "C" */
#endif

#endif // USBLC3301X64_H
